import { BFHMoreButton } from "./Buttons";
import SimpleSlider from "./slider";




interface ItemProps {
    text?: string; 
    heading?: string; 
    vorname?: string, 
    vorname2?: string, 
    nachname?: string,
    nachname2?: string,
    date: string ,
    children: React.ReactNode;
    tag: string, 
    color: string,
    csstag: string,
    url: string,
    url2?: string
}



/* import ImageEvent from './ImageEvent.tsx';
import UrlButton from './UrlButton.tsx'; */
export const TimelineItemPic  = ({ heading, text, vorname, nachname, date, tag, color, children, csstag, url }:ItemProps) => (
    <div className="timeline-item">
        <div className="timeline-item-content">
            <span className="tag" style={{ background: color }}>
                {tag}
            </span> 
            <time>{date}</time>
            
            <hr/>
            <div className="row">
                <div className="col">
                    <figure className="snip1113 red">
                        <img src={url} alt={nachname} />
                        <figcaption>
                            <h3>{vorname} <br/> <span>{nachname}</span></h3>
                        </figcaption>
                    </figure>
                </div>
                <div className="col text-1-bfh">
                    <h5>{heading}</h5>
                    <span className="">{text}</span>
                </div>
                {children}
            </div>
            
            <BFHMoreButton it={csstag}></BFHMoreButton>
            <span className="circle" />
        </div>
    </div>
);

export const TimelineItemTwoPic  = ({ url, url2, heading, text, vorname, nachname, vorname2, nachname2, date, tag, color, children, csstag }:ItemProps) => (
    <div className="timeline-item">
        <div className="timeline-item-content">
            <span className="tag" style={{ background: color }}>
                {tag}
            </span> 
            <time>{date}</time>
            
            <hr/>
            <div className="row">
                <div className="col">
                    <figure className="snip1113 red">
                        <img src={url} alt={nachname} />
                        <figcaption>
                            <h3>{vorname} <br/> <span>{nachname}</span></h3>
                        </figcaption>
                    </figure>
                </div>
                <div className="col">       
                    <figure className="snip1113 red">
                        <img src={url2} alt={nachname2} />
                        <figcaption>
                            <h3>{vorname2} <br/> <span>{nachname2}</span></h3>
                        </figcaption>
                    </figure>
                </div>
                <div className="col text-1-bfh">
                    <h5>{heading}</h5>
                    <span className="">{text}</span>
                </div>
                {children}
            </div>
            
            <BFHMoreButton it={csstag}></BFHMoreButton>
            <span className="circle" />
        </div>
    </div>
);

export const TimelineItem  = ({ date, tag, color, children, csstag }:ItemProps) => (
    <div className="timeline-item">
        <div className="timeline-item-content">
            <span className="tag" style={{ background: color }}>
                {tag}
            </span> 
            <time>{date}</time>
            
            <hr/>
            {children}
            
            <BFHMoreButton it={csstag}></BFHMoreButton>
            <span className="circle" />
        </div>
    </div>
);

export const PanelTimelineItem  = () => (
    <div className="timeline-item">
        <div className="timeline-item-content">
            <span className="tag" style={{ background: "var(--lightblue)" }}>
                Talks
            </span> 
            <time>Panel Discussion</time>
            <div className="row align-items-center panel-talk-gallery">
                <div className="col">
                    <img className="img-round" src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg" alt="pr-sample1" />
                    <div className="small middle">Taci <br/> Haddock</div>
                </div>
                <div className="col">
                    <img className="img-round"  src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg" alt="pr-sample1" />
                    <div className="small middle">Ana <br/> Sifuentes</div>
                </div>
                <div className="col">
                    <img className="img-round"  src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg" alt="pr-sample1" />
                    <div className="small middle">Olivia <br/> Mozolewska</div>
                </div>
                <div className="col">
                    <img className="img-round"   src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg" alt="pr-sample1" />
                    <div className="small middle">Lasse <br/> Middendorf</div>
                </div>
                <div className="col">
                    <img className="img-round"  src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg" alt="pr-sample1" />
                    <div className="small middle">Nemanja <br/> Stijepovic</div>
                </div>
            </div>
            <hr/>
            <span>Panel Discussion</span>
                    <div id="panel" style={{display: "none"}}>
                        So much more
                    </div>  
            
            <BFHMoreButton it="panel"></BFHMoreButton>
            <span className="circle" />
        </div>
    </div>
);



export function MyTimeline () {
    return(
        <>
            <div className="timeline-container">
                <div className='timeline-begin'>
                Begin & Opening
                </div>

                <TimelineItemTwoPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                url2="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='Scientific Talk I.'
                tag= 'Talks'
                color='var(--lightblue)'
                csstag="talkone"
                vorname="Kristian"
                vorname2="Ram"
                nachname="Müller"
                nachname2="Shakar"
                heading="placeholder"
                text="Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et"
                >
                    <div id="talkone" style={{display: "none"}}>
                        So much more
                    </div>

                </TimelineItemTwoPic>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='How to Wiki'
                tag='Workshop Session I.'
                color='var(--text-primary)'
                csstag="wikiworkshop"
                vorname="Christian"
                nachname="Kolland"
                heading="placeholder"
                text="Learning the basics of Wiki coding and design. In this workshop, the participants geined expertise to elevate their teams wiki."
                >
                <div id="wikiworkshop" style={{display: "none"}}>
                        so much more
                </div>
                </TimelineItemPic>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='How to SynBio'
                tag='Workshop Session I.'
                color='var(--text-primary)'
                csstag="synworkshop"
                vorname="Traci"
                nachname="Haddock"
                text="Design genetic constructs and re-write the genomic code, and plan experiments using AI. Learn how to effectively build genetic circuit systems for implementation in your iGEM project.
                "
                heading="placeholder"
                >
                <div id="synworkshop" style={{display: "none"}}>
                        So much more
                </div>
                </TimelineItemPic>
                <TimelineItemTwoPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                url2="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='How to use AI as a scientist'
                tag='Workshop Session I.'
                color='var(--text-primary)'
                csstag="aiworkshop"
                >
                    <h5>Modern problems require modern solutions</h5>
                    <span>Computational technologies are getting more in the focus of scientific research. Integration of generative KI like GenAI bypass limitations and offers potential risks - learn how to implement Artificial Intelligence.
                    </span>
                    <div id="aiworkshop" style={{display: "none"}}>
                        So much more
                    </div> 
                </TimelineItemTwoPic>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='Scientific Talk II.'
                tag= 'Talks'
                color='var(--lightblue)'
                csstag="talktwo"
                vorname="Karla"
                nachname="Wagner"
                heading="placeholder"
                text="Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et"
                >
                    <div id="talktwo" style={{display: "none"}}>
                        So much more
                    </div> 
                </TimelineItemPic>
                <TimelineItem
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='Team project presentations'
                tag= 'Team presentations'
                color='var(--accent-primary'
                csstag="teampres"
                >
                    <h5>Team project presentations</h5>
                    <div className="col bfh-slider">
                    <SimpleSlider>
                    <img className="" src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"/>
                    <img className="" src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"/>
                    <img className="" src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"/>
                    </SimpleSlider>
                    </div>
                    <span>

                    </span>
                    <div id="teampres" style={{display: "none"}}>
                        So much more
                    </div> 
                </TimelineItem>
                <TimelineItem
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='Poster Exhibition Booth'
                tag= 'Team presentations'
                color='var(--accent-primary)'
                csstag="teambooth"
                >
                    <h5>Poster Exhibition Booth </h5>
                    [Link virtual exhibition]
                    <div className="col bfh-slider">
                    <SimpleSlider>
                    <img className="" src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"/>
                    <img className="" src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"/>
                    <img className="" src="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"/>
                    </SimpleSlider>
                    </div>
                    <span>

                    </span>
                    <div id="teambooth" style={{display: "none"}}>
                        So much more
                    </div> 
                </TimelineItem>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='How to work safe'
                tag='Workshop Session II.'
                color='var(--text-primary)'
                csstag="safeworkshop"
                vorname="Svenja"
                nachname="Vinke"
                heading="About Dual-use and Biosafety"
                text="Novel technologies opened possibilities and risks. Learn how you implement Safety and Security Strategies within your project and think more responsible in terms of Dual Use."
                >
                    <div id="safeworkshop" style={{display: "none"}}>
                        <p>The biosafety workshop was held by Svenja Vinke. Svenja is a postdoctoral researcher specializing in 
                            synthetic biology at the Church Lab, Harvard Medical School, and serves on the Safety and Security 
                            Committee of iGEM. She started by outlining the key concepts of biosafety and biosecurity and emphasized 
                            how important laboratory safety is first and foremost.  </p>
                        <p>She also explained which safety aspects we should consider for our project:  </p>
                        <ul>
                            <li>    possible misuse (dual use)  </li>
                            <li>    built-in safety levels </li>
                            <li>    if possible, several built in security mechanisms or at least recognizable that safety strategies that have been worked  </li>
                        </ul>
                        <p>This particularly applies to any delivery systems that can address their target particularly efficiently, 
                            as these systems could be the center of potential misuse.  </p>
                        <p>Finally, each team gave brief presentations of their projects and engaged in a group discussion on potential 
                            security risks and general security considerations. Together, we brainstormed and identified specific 
                            aspects of each project that could present potential risks. </p>
                        <p>From Svenja’s seminar, we learned which safety-relevant aspects are particularly important, as well as 
                            the importance of examining a project from different perspectives to identify and minimize potential 
                            risks related to lab work and the environment. </p>
                    </div> 
                </TimelineItemPic>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='How to Communicate Science'
                tag='Workshop Session II.'
                color='var(--text-primary)'
                csstag="commworkshop"
                text="Experience how science communication could be. Learn creative and funny ways to communicate difficult topics. Think outside the box and train your skills. "
                >
                    <br></br>
                    
                    <div id="commworkshop" style={{display: "none"}}>
                        <br></br>
                        <h6>Setting</h6>
                        <p>
                        This workshop was offered to us by <a href="https://www.stud-scicom.de/">StudSciCom</a>.
                        StudSciCom is an initiative for science communication by students for students in Germany. 
                        They held this workshop for us for the very first time and we are glad that we were able to offer the 
                        uprising StudSciCom team a platform to try out this kind of outreach. In addition, we were able to gain 
                        knowledge about proper science communication –  a clear win-win situation for all of us!
                        </p>
                        <h6>What did we learn?</h6>
                        <p>
                        Julia Kalinowski, PhD at Bielefeld University and Foreign Minister of StudSciCom, together with Carolin Malmendier, 
                        former physics student and now organizer in the StudSciCom team, introduced us to the theories and  practice 
                        of different types of science communication and how to develop a communication strategy. 
                        In detail, we were taught to ask ourselves several questions to define our topic, the medium of 
                        communication, as well as the characterization of our target group and the planned achievement with our 
                        science communication. 
                        </p>
                        <img src="https://static.igem.wiki/teams/5247/photos/other/vortrag-scicom-bfh-screenshot.jpg"></img>
                        <p>The key message for us was to plan the science communication before we dive in and to make sure that the 
                            target audience gets the message we want to send.  </p>
                        <h6>Implementation</h6>
                        <p>
                        Afterwards, the attending iGEM teams talked about their science communication plans and how they could improve them 
                        using the skills learned in this workshop. Our team revised their plans for explaining gene editing to 
                        children and started developing experiments to help them better understand cystic fibrosis, which we 
                        presented later onto the public at “Der Teuto ruft!” [Link], an event in Bielefeld to connect the local 
                        population with regional companies and institutes to inform them about their work - including our iGEM team! 
                        </p>
                        </div>    
                </TimelineItemPic>
                <TimelineItemPic
                date='How to Pitch Your Project'
                tag='Workshop Session II.'
                color='var(--text-primary)'
                csstag="pitch"
                url="https://static.igem.wiki/teams/5247/photos/meetup/speakers/madeleine-mussgnug.jpg"
                vorname="Madeleine"
                nachname="Mussgnug"
                heading="placeholder"
                text="Image you have only three minutes with your boss to sell your idea... 
                After our workshop you learned techniques to sell every pen and even more to every boss on the planet.       
               "
                > 
                <div id="pitch" style={{display: "none"}}>
                        So much more
                    </div>  
                </TimelineItemPic>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='How to Multi Media'
                tag='Workshop Session II.'
                color='var(--text-primary)'
                csstag="multimedia"
                vorname="Michael"
                nachname="Gröning"
                heading="placeholder"
                text="Learn the basics of filmmaking and video production. 
                Look behind the scenes and get in touch with professionals. 
                Train your skills to direct iGEM-related videos and movies."
                > 
                
                <div id="multimedia" style={{display: "none"}}>
                        So much more
                    </div>  
                </TimelineItemPic>
                <PanelTimelineItem></PanelTimelineItem>
 
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='iGEMer Ted Talks'
                tag= 'Talks'
                color='var(--lightblue)'
                heading="Secrets to award-winning bioinformatics tools"
                text="Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et"
                vorname="Lasse"
                nachname="Middendorf"
                csstag="tedtalk1"
                >
                    <div id="tedtalk1" style={{display: "none"}}>
                        <p>Lasse’s Ted talk was all about how to create good bioinformatics software. He himself was part of 
                            the dry lab in iGEM Münster’s Team that won the best software special prize in 2022. The tool they 
                            created allowed users to generate knockout candidates for an organism of their choice that would 
                            lead to redirection of metabolic flux to a reaction chosen by the user. We learned that the most 
                            important attributes for a successful bioinformatics software are: </p>
                        <ul>
                            <li><b>Usefulness </b></li>
                            <li><b>Accessibility</b></li>
                            <li><b>Build upon existing standards  </b></li>
                        </ul>
                        <p>To ensure usefulness, the software should be generalized and not only usable in the context of one’s 
                            own project. Also, all steps that can be automated should be automated. Accessibility, Lasse said, 
                            requires for the software to be easy to install, easy to use and well documented.  </p>
                        <p>As a funny, but also very fitting anecdote, Lasse told us about the HU test. For testing their own tool for 
                            accessibility, he gave a bioinformatically unexperienced, <b>h</b>ungover <b>u</b>ndergraduate student 
                            nothing but the software with the provided documentation. If the student can use the tool in a reasonable 
                            amount time, that would make it accessible enough for everyone. Furthermore, Lasse also recommended making 
                            a command line tool for better availability over time and integration into other workflows. Lastly, the 
                            software should use standard data files like CSV, Fasta etc. and be written in commonly used programming 
                            languages like Python. </p>
                        <p>Overall, Lasse gave a great insight into the properties of a special price winning software tool and very 
                            practically explained how these can be tested and achieved, information that is invaluable for us when 
                            creating our own bioinformatics tool. </p>
                    </div>  
                </TimelineItemPic>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='iGEMer Ted Talks'
                tag= 'Talks'
                color='var(--lightblue)'
                csstag="tedtalk2"
                vorname="place"
                nachname="holder"
                heading="placeholder"
                text="Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et"
                >
                    <div id="tedtalk2" style={{display: "none"}}>
                        So much more
                    </div>  
                </TimelineItemPic>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='First Science Slam'
                tag= 'Talks'
                color='var(--lightblue)'
                csstag="slam1"
                heading="ChatGPT and Large Language Models"
                nachname="Vaquet"
                vorname="Jonas"
                text="At this year's BFH Meetup, experienced slammers and FameLab [Link] participants were once again able to take 
                            to the stage and present their scientific topic as simply as possible in 5 minutes. "
                >
                    <div id="slam1" style={{display: "none"}}>
                    <p>With Jonas Vaquet, a 
                            research associate of the EU project ERC Waterfutures [Link], the audience explored Large Language Models 
                            (LLMs) such as ChatGPT. The speaker humorously engaged the crowd, asking who had used such models, and 
                            nearly all hands were raised in response. </p>
                        <p>The speaker introduced ChatGPT, a "Generative Pre-trained Transformer," using an interactive experiment where 
                            the audience predicted the next words in sentences, showing how the model works with pre-trained data and 
                            calculates text continuations. </p>
                        <p>While it is fair to say that ChatGPT is a powerful and helpful tool, it is important to focus on the potential 
                            dangers and challenges it brings, which Jonas summarizes in three key factors in his talk: </p>
                        <ul>
                            <li><b>Plagiarism Risks:</b> The speaker demonstrated how easy it is to unintentionally replicate existing 
                            works, using a Harry Potter example to illustrate plagiarism risks in creative writing.</li>
                            <li><b>Hallucinations:</b> Language models can generate plausible but incorrect information, exemplified 
                            by a fictitious CV with invented grades, highlighting risks in academic and professional use.</li>
                            <li><b>Lack of Opinion Formation:</b> ChatGPT does not form real opinions, leading to inconsistent 
                            answers when asked for preferences.</li>
                        </ul>
                        <p>Although large language models (LLMs) are trained with extensive collection of texts or spoken language, 
                            they often fail in the accuracy required for scientific topics. Sources are seemingly conjured out of 
                            thin air and claims vanish into thin air because their answers are based on statistical probabilities, 
                            leading to confusion, especially for niche questions. </p>
                        <p>Jonas ended his talk by giving the audience food for thought. He reminded everyone who had eagerly 
                            raised their hands at the beginning to always double-check ChatGPT's information, especially in 
                            academic and professional settings. </p>
                        <p>With his interactive and humorous approach, Jonas turned the complex world of LLMs into an engaging 
                            and accessible adventure, offering deep insights into the workings and idiosyncrasies of this 
                            fascinating technology. </p>
                    </div>  
                </TimelineItemPic>
                <TimelineItemPic
                url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
                date='Second Science Slam'
                tag= 'Talks'
                color='var(--lightblue)'
                csstag="slam2"
                heading="Microalgae for Sustainable Food Production "
                text="Niklas, a biotechnologist and PhD student at the Faculty of Engineering at Bielefeld University, used his experience from previous science slams and his participation in a previous iGEM competition to present microalgae in a new light."
                vorname="Niklas"
                nachname="Bloebaum"
                >
                    <div id="slam2" style={{display: "none"}}>
                        <p>With insights into his current research, Niklas introduced the audience to the innovative uses of chlorella 
                            for sustainable food production. </p>
                        <p>The star of the show was the smallest vegetable in the world Chlorella is tiny (4 to 12 microns) but 
                            very rich in nutrients: 45-65% protein, 10-20% fat, 10-20% carbohydrates, 5% fiber and various 
                            vitamins and minerals, including vitamin B12. </p>
                        <p>Nicholas presented two production methods: </p>
                        <ul>
                            <li><b>open pond systems:</b>these utilize light, CO₂ and water for photosynthesis, but have the problem 
                            of the availability of light and water.</li>
                            <li><b>bioreactors:</b>modern, controlled, sterile environments that utilize sugar as an energy source, 
                            significantly increase productivity and reduce water consumption.</li>
                        </ul>
                        <p>Bioreactors are up to 100 times more productive and use 100 times less water than conventional methods. 
                            Sounds perfect, right? But Nicholas had to burst the bubble and make it clear that the technology 
                            still needs to be developed further.  </p>
                        <p>In terms of sustainability, Nicholas had to emphasize that the whole process of microalgae production needs 
                            to be questioned. He noted that the current carbon footprint calculations for bioreactors are outdated. 
                            But fear not, our brave biotechnologist is on a mission to bring these figures up to date with his 
                            groundbreaking research! </p>
                        <p>The curious audience asked questions about scalability, costs and sustainable sugar sources. Always up for a 
                            challenge, Nicholas explained that the current high costs could be addressed by improving the productivity 
                            of the bioreactors! However, he also emphasized that further research is needed to find a sustainable 
                            source of sugar. </p>
                        <p>In his grand finale, Nicholas presented three wise insights: </p>
                        <ul>
                            <li><b>biotechnology</b> goes far beyond medicine and opens the doors for sustainable food production.</li>
                            <li><b>sustainability </b> assessments must consider the entire production process - no detail should be overlooked!</li>
                            <li><b>chlorella</b>, the tiny, nutrient-rich microalgae, has the potential to be a hero in our future diet. </li>
                        </ul>
                        <p>Nicholas captivated the audience with his vivid and eye-opening presentation. He guided them through the fascinating 
                            and sometimes turbulent world of microalgae production, highlighting the challenges and opportunities of 
                            this technology. The audience was not only informed but also entertained and ready to embrace the future 
                            of sustainable nutrition with chlorella as their little green hero. </p>
                    </div>  
                </TimelineItemPic>
                <div className='timeline-end'>
                    Award Ceremony
                </div>
            </div>
            
            </>
        )
    
}
